#if 0
#* mundelete *
#DATE:		26 / 06 / 2002
#endif
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include <sys/stat.h>
#include <ctype.h>

#define VERSION "0.1"
#define FTW_D 0xA
#define FTW_DNR 0xB
#define FTW_NS 0xC
#define FAT12 0x0C
#define FAT16 0x10
#define FAT32 0x20
#define SUBDIR 0x10
#define DELETED 0xE5
#define EOCLUST 0x0FFFFFF8U
#define ROOTLENGHT 12
#define AUTODETECT 0
#define FREECLUST 0
#define clust12_16(X) ((RESSECT+FATCNT*FATSIZE+ROOTLENGHT+X*CLUSTSIZE)*SECTSIZE)
#define clust32(X) ((RESSECT+FATCNT*FATSIZE-ROOTDIR+X*CLUSTSIZE)*SECTSIZE)
#define clust(X) ((FILESTYPE != FAT32) ? clust12_16(X):clust32(X))
#define is_deleted(X) ((X)->FILENAME[0]==DELETED)
#define is_vfat_entry(X) ((X)->CLUSTNUM==0 && (X)->FILESIZE)	/* in vfat delfn always contain 0F */
#define is_eoclust(X) ((FILESTYPE==FAT12) ? (X>=(EOCLUST&0xFFF)):((FILESTYPE==FAT16) ? (X>=(EOCLUST&0xFFFF)):(X>=EOCLUST)))
#define is_freeclust(X) (X==FREECLUST)
#define upcase(X) (!isalpha(X) ? X:(X>'A' && X<'Z') ? X:(X-('a'-'A')))
#define isdir(X) (((X)->ATRIB & SUBDIR) == SUBDIR)
#define isdot(X) (!strncmp((X)->FILENAME,".          ",11) || !strncmp((X)->FILENAME,"..         ",11))
int fd;
char *original_path;
short SECTSIZE;
char CLUSTSIZE;
short RESSECT;
char FATCNT;
short FATSIZE;
char FILESTYPE = AUTODETECT;
int ROOTDIR;

char UNDELETE_CHAR = 'U';
char RECURSIVE = 1;
char UNDELETE_RECURSIVE = 0;
struct boot
{
  char JMP[3];
  char OEM[8];
  short SECTSIZE;
  char CLUSTSIZE;
  short RESSECT;
  char FATCNT;
  short ROOTSIZE;
  short TOTALSECT;
  char MEDIA;
  short FATSIZE;
  short TRACKSECT;
  short HEADCNT;
  int HIDENSECT;
  int HUGESECT;
  char DRIVENUM;
  char RESERV;
  char BOOTSIGN;
  int VOLID;
  char VOLABEL[11];
  char FILESTYPE[8];

};

char null = '\0';

struct dir
{
  unsigned char FILENAME[8];	/* i need unsigned due of limited range of data */
  char FILEEXT[3];
  char ATRIB;
  char RESERV[10];
  short TIME;
  short DATE;
  short CLUSTNUM;
  int FILESIZE;
};

inline void undelete (unsigned int);

inline off_t
seek (off_t pos, int whence)
{
  off_t ret;
  if ((ret = lseek (fd, pos, whence)) == -1)
    exit (1);
  return ret;
}

inline void
upper_case (char *s)
{

  for (; *s; s++)
    *s = upcase (*s);
}


inline void
init (int argc, char **argv)
{
  int ret;
  while ((ret = getopt (argc, argv, "vrRhF:")) >= 0)
    {
      switch (ret)
	{
	case 'v':
	  printf ("mundelete version %s\n", VERSION);
	  exit (0);
	case '?':
	  printf ("Try %s -h for more information\n", argv[0]);
	  exit (1);
	case 'c':
	  UNDELETE_CHAR = *optarg;
	  break;
	case 'F':
	  FILESTYPE = atoi (optarg);
	  break;
	case 'r':
	  RECURSIVE = 1;
	  break;
	case 'R':
	  RECURSIVE = 1;
	  UNDELETE_RECURSIVE = 1;
	  break;
	case 'h':
	  printf
	    ("*mundelete* undeletes files with (possibly) relative data from MsDos/Windows file systems\n");
	  printf ("Usage: mundelete [OPTION]... DEVICE... [DIRECTORY]\n");
	  printf ("OPTION:\n");
	  printf
	    ("-F FAT-size	Specifies the type of file allocation tables used (12,16 or 32 bit). If 0 or nothing specified, mundelete will autodetect it, else it will select FAT12\n");
	  printf
	    ("-c UNDELETE_CHAR Specifies the character used instead of first character of a undeleted entry. If nothing specified mundelete will use 'U'. In vfat file system you don't need this option because mundelete get first character of the deleted file from the relative vfat entry\n");

	  printf
	    ("-r 		Walk through the directory tree starting from the indicated directory DIRECTORY, if specified, else from the dot entry in the root dir. For each found directory in the tree undeletes files contained in\n");
	  printf
	    ("-R 		Same as -r but also walk through each entry undeleted. That is, it undeletes all on the disk\n");
	  exit (0);

	  exit (0);

	}

    }
  if (!argv[optind])
    {
      printf ("no DEVICE specified\n");
      exit (1);
    }
  else if (!strcmp (argv[optind], "-"))
    argv[optind] = "/dev/stdin";
  if ((fd = open (argv[optind], O_RDWR)) < 0)
    {
      printf ("unable to open device %s\n", argv[optind]);
      exit (1);
    }
  if (argv[optind + 1])
    {
      upper_case (argv[optind + 1]);
      original_path = argv[optind + 1];
    }
  else
    original_path = &null;
}

inline void
readsect (char *buf, size_t count)
{
  int n, err;
  for (n = 0;
       (err = read (fd, buf + n, count - n)) > 0 && (n += err) < count;);
  if (n < count)
    exit (1);			/* if n< count there is sure an error,therefore last read returned -1 or premature end of file */
}


inline void
boot_padding (char *boot)
{
  struct boot boot2;
  memcpy (&boot2.JMP, boot, 3);
  memcpy (&boot2.OEM, boot + 3, 8);
  memcpy (&boot2.SECTSIZE, boot + 11, 2);
  memcpy (&boot2.CLUSTSIZE, boot + 13, 1);
  memcpy (&boot2.RESSECT, boot + 14, 2);
  memcpy (&boot2.FATCNT, boot + 16, 1);
  memcpy (&boot2.ROOTSIZE, boot + 17, 2);
  memcpy (&boot2.TOTALSECT, boot + 19, 2);
  memcpy (&boot2.MEDIA, boot + 21, 1);
  memcpy (&boot2.FATSIZE, boot + 22, 2);
  memcpy (&boot2.TRACKSECT, boot + 24, 2);
  memcpy (&boot2.HEADCNT, boot + 26, 2);
  memcpy (&boot2.HIDENSECT, boot + 28, 4);
  memcpy (&boot2.HUGESECT, boot + 32, 4);
  memcpy (&boot2.DRIVENUM, boot + 36, 1);
  memcpy (&boot2.RESERV, boot + 37, 1);
  memcpy (&boot2.BOOTSIGN, boot + 38, 1);
  memcpy (&boot2.VOLID, boot + 39, 4);
  memcpy (&boot2.VOLABEL, boot + 43, 11);
  memcpy (&boot2.FILESTYPE, boot + 54, 8);
  *(struct boot *) boot = boot2;
}

inline void			/* this function should not be useful */
dir_padding (char *dir)
{
  struct dir dir2;
  memcpy (&dir2.FILENAME, dir, 8);
  memcpy (&dir2.FILEEXT, dir + 8, 3);
  memcpy (&dir2.ATRIB, dir + 11, 1);
  memcpy (&dir2.RESERV, dir + 12, 10);
  memcpy (&dir2.TIME, dir + 22, 2);
  memcpy (&dir2.DATE, dir + 24, 2);
  memcpy (&dir2.CLUSTNUM, dir + 26, 2);
  memcpy (&dir2.FILESIZE, dir + 28, 4);

  *(struct dir *) dir = dir2;

}

inline void
fat32_init (void)
{
  ROOTDIR = 2;
  FATSIZE = 22;

}


inline void
get_param (void)
{
  struct boot boot;

  readsect ((char *) &boot, sizeof (struct boot));
  boot_padding ((char *) &boot);
  SECTSIZE = boot.SECTSIZE;
  CLUSTSIZE = boot.CLUSTSIZE;
  RESSECT = boot.RESSECT;
  FATCNT = boot.FATCNT;

  if (FILESTYPE == AUTODETECT)
    {

      if ((FATSIZE = boot.FATSIZE) == 0)
	FILESTYPE = FAT32;
      else if (!strncmp (boot.FILESTYPE, "FAT16", sizeof ("FAT16") - 1))
	FILESTYPE = FAT16;
      else if (!strncmp (boot.FILESTYPE, "FAT12", sizeof ("FAT12") - 1))
	FILESTYPE = FAT12;
      else
	{
	  printf ("no know file system type...Trying with FAT12\n");
	  FILESTYPE = FAT12;
	}

    }
  if (FILESTYPE == FAT32)
    fat32_init ();

}

inline void
seek_root (void)
{
  seek ((FATSIZE * FATCNT + RESSECT) * SECTSIZE, SEEK_SET);
}

inline int
readrootdir (struct dir *dir)
{
  unsigned int tmp;
  off_t pos;

  tmp = clust (ROOTDIR);

  pos = seek (0, SEEK_CUR);
  if (pos == tmp)
    return 0;
  readsect ((char *) dir, sizeof (struct dir));
  return 1;
}

inline void
is_dir (struct dir *dir)
{
  if (!isdir (dir))
    {
      dir->FILENAME[8 + 3] = '\0';
      printf ("%s not a directory\n", dir->FILENAME);
      exit (1);
    }
}

inline void
seek_clust (unsigned int next)
{
  seek (clust (next), SEEK_SET);
}


inline unsigned int
next_clust (unsigned int clust)
{
  unsigned int next;
  unsigned int block[FATSIZE * SECTSIZE / sizeof (int)];
  seek (RESSECT * SECTSIZE, SEEK_SET);
  readsect ((char *) block, FATSIZE * SECTSIZE);
  next = ((int *) ((char *) block + (clust * FILESTYPE / 8)))[0];
  if ((clust * FILESTYPE) % 8) {
    unsigned int tmp = next;
    next = tmp >> 4;
  }
  else if (FILESTYPE == FAT12)
    next &= 0x0FFF;
  if (is_eoclust (next))
    return EOCLUST;
  seek_clust (next);
  return next;

}


inline int
readclust (struct dir *dir, unsigned short int clustnum)
{
  off_t pos;
  pos = seek (0, SEEK_CUR);
  if (!clustnum)
    {
      if (clust (0) == pos)
	return 0;
    }
  else if (clust (clustnum) + CLUSTSIZE * SECTSIZE == pos)
    return 0;

  readsect ((char *) dir, sizeof (struct dir));
  return 1;

}

inline char *
get_direntry (char **path)
{
  char *ret, *tmp;
  if (!**path)
    return NULL;
  if ((tmp = ret = malloc (11)) == NULL)
    exit (1);
  for (; **path != '/' && **path; (*path)++)
    *ret++ = **path;
  if (**path == '/')
    (*path)++;
  *ret = '\0';
  return tmp;

}



inline unsigned int
get_clust (char FAT[], unsigned int clustnum)
{
  if (FILESTYPE == FAT12)
    {
/* (0FFF)(F)FF8 = END OF CLUST IN FAT12/FAT16/FAT32 */
      if ((clustnum * FILESTYPE) % 8)
	return ((short *) ((char *) FAT + (clustnum * FILESTYPE / 8)))[0] >>
	  4;
      else
	return ((short *) ((char *) FAT + (clustnum * FILESTYPE / 8)))[0] &
	  0xFFF;
    }
  else if (FILESTYPE == FAT16)
    return ((short *) ((char *) FAT + (clustnum * FILESTYPE / 8)))[0];
  else
    return ((int *) ((char *) FAT + (clustnum * FILESTYPE / 8)))[0];
}


inline void
put_clust (char FAT[], unsigned int value, unsigned int clustnum)
{
  if (FILESTYPE == FAT12)
    {
/* (0FFF)(F)FF8 = END OF CLUST IN FAT12/FAT16/FAT32 */
      if ((clustnum * FILESTYPE) % 8)

	((short *) ((char *) FAT + (clustnum * FILESTYPE / 8)))[0] |=
	  (unsigned short) value << 4;
      else
	((short *) ((char *) FAT + (clustnum * FILESTYPE / 8)))[0] |=
	  value & 0xFFF;
    }
  else if (FILESTYPE == FAT16)

    ((unsigned short *) ((char *) FAT + (clustnum * FILESTYPE / 8)))[0] =
      (unsigned short) value;
  else
    ((unsigned int *) ((char *) FAT + (clustnum * FILESTYPE / 8)))[0] = value;
}


inline void
writeclusters (struct dir *dir)
{
  unsigned int clustnum;
  int size;
  char FAT[SECTSIZE * FATSIZE];
  seek (RESSECT * SECTSIZE, SEEK_SET);

  readsect (FAT, sizeof (FAT));

/* undelete data clusters */
  for (size = SECTSIZE * CLUSTSIZE, clustnum = dir->CLUSTNUM;
       size < dir->FILESIZE && is_freeclust (get_clust (FAT, clustnum + 1));
       clustnum++, size += SECTSIZE * CLUSTSIZE)
    {
      put_clust (FAT, clustnum + 1, clustnum);
    }

  put_clust (FAT, EOCLUST, clustnum);

  seek (RESSECT * SECTSIZE, SEEK_SET);
  if (write (fd, FAT, sizeof (FAT)) != sizeof (FAT))
    exit (1);
}



/*unsigned char checksum(char *s){
unsigned char csum=0;
int i;
for(i=0;i<11;i++) csum=((csum>>1)| ((csum&1)<<7))+s[i];
return csum;
}*/

inline void
vfat (struct dir *d)
{
  struct dir dir[64];		/* max number of vfat entry (precisally we already have read one of it, but we read next possible 63 vfat entry+ normal de allowing */
  int i = 1, x;
  off_t pos;
  dir[0] = *d;
  for (;;)
    {
      readsect ((char *) &dir[i], sizeof (struct dir));
      if (!is_vfat_entry (&dir[i]))
	break;
      i++;
    }
  dir[i].FILENAME[0] = upcase (dir[i - 1].FILENAME[1]);
  *d = dir[i];
  for (x = 0; x < i; x++)
    {

      dir[x].FILENAME[0] = i - x;
      dir[x].ATRIB = 0x0F;
    }
  dir[0].FILENAME[0] |= 0x40;

  pos = seek (0, SEEK_CUR);
  seek (-sizeof (struct dir) * (i + 1), SEEK_CUR);
  if (write (fd, dir, sizeof (struct dir) * i) != sizeof (struct dir) * i)
    exit (1);
  seek (pos, SEEK_SET);
}


inline void
writedir (struct dir *dir)
{
  off_t pos;
  if (is_vfat_entry (dir))
    vfat (dir);
  else
    dir->FILENAME[0] = UNDELETE_CHAR;	/* for vfat entry set first char in vfat() */


  printf ("undeleting file %s\n", dir->FILENAME);
  pos = seek (-sizeof (struct dir), SEEK_CUR);

  writeclusters (dir);

  pos = seek (pos, SEEK_SET);

  if (write (fd, dir, sizeof (struct dir)) != sizeof (struct dir))
    exit (1);
}


inline void
recursive (struct dir *dir)
{
  off_t pos;
  if (!RECURSIVE || !isdir (dir) || isdot (dir))
    return;
  pos = seek (0, SEEK_CUR);
  undelete (dir->CLUSTNUM);
  seek (pos, SEEK_SET);
}

inline void
undelete (unsigned int clustnum)
{
  struct dir dir;
  if (clustnum)
    seek_clust (clustnum);	/*  for FAT12/FAT16 undelete is called with clustnum=0, therefore we don't must seek_clust() at cluster 0, which is not the start of root directory but the start of first data cluster. Instead in FAT32 root directory is on cluster 2, which is also a data cluster (that is, in FAT32, there is no difference between root dir and a normal dir) */

  for (; !is_eoclust (clustnum); clustnum = next_clust (clustnum))
    {
      while (readclust (&dir, clustnum))
	{
	  recursive (&dir);
	  if (is_deleted (&dir))
	    {
	      writedir (&dir);
	      if (UNDELETE_RECURSIVE)
		recursive (&dir);
	    }

	}
      if (!clustnum)		/* If we were searching in root dir in FAT12/16, there is not other cluster to allow */
	return;
    }



}



inline int
mystrcmp (char *s, char *s2)
{
  for (; *s && *s != ' ' && *s2 && *s2 != ' '; s++, s2++)
    if (*s != *s2)
      return 1;
  if ((!*s || *s == ' ') && (!*s2 || *s2 == ' '))
    return 0;
  return 1;
}

inline void
visit_fs (char *path, unsigned int clustnum)
{
  struct dir dir;
  char *dn;
  dn = get_direntry (&path);
  if (!dn)
    {
      undelete (clustnum);
      return;
    }
  for (; !is_eoclust (clustnum); clustnum = next_clust (clustnum))
    {
      while (readclust (&dir, clustnum))
	{
	  if (!mystrcmp (dn, dir.FILENAME))
	    {
	      is_dir (&dir);
	      clustnum = dir.CLUSTNUM;
	      free (dn);
	      dn = get_direntry (&path);
	      if (!dn)
		{
		  undelete (clustnum);
		  return;
		}
	      seek_clust (clustnum);
	    }

	}

    }
  printf ("no such directory %s on this device\n", original_path);
  exit (1);



}




inline void
root_dir (char *path)
{
  struct dir dir;
  char *dn;
  seek_root ();
  if (FILESTYPE == FAT32)
    {
      visit_fs (path, ROOTDIR);
      return;
    }
  dn = get_direntry (&path);
  if (!dn)
    {
      undelete (ROOTDIR);
      return;
    }
  while (readrootdir (&dir))
    {
      if (!mystrcmp (dn, dir.FILENAME))
	{
	  is_dir (&dir);
	  free (dn);
	  visit_fs (path, dir.CLUSTNUM);

	  return;
	}

    }
  printf ("no such directory %s on this device\n", original_path);
  exit (1);
}


int
main (int argc, char **argv)
{

  init (argc, argv);

  get_param ();
  root_dir (original_path);

  return 0;
}
